#ifndef HistorieStatistik_H
#define HistorieStatistik_H

#include <AccountHistorieStatistikV.h>
#include "../SpielStatistik/SpielStatistikDaten.h"
#include "../SpielStatistik/Tabelle/StatistikTabelle.h"

class HistorieStatistik : public AccountHistorieStatistikV
{
private:
    UIInit uiFactory;
    Bildschirm *screen;
    Array< SSDSpieler * > *gss;
    Array< SSDTeam * > *gts;
    StatistikTabelle *tabelle;
    Knopf *fertig;
    bool geladen;
    bool geschlossen;
    unsigned char alpha;
    bool sichtbar;
    double tickVal;
    bool rend;

public:
    // Konstruktor
    HistorieStatistik();
    // Destruktor
    ~HistorieStatistik();
    // nicht constant
    virtual void setUIFactory( UIInit &uiFactory );
    virtual void ladeDaten( int spielId );
    virtual void setSichtbar( bool sichtbar );
    virtual void doPublicMausEreignis( MausEreignis &me );
    virtual void doTastaturEreignis( TastaturEreignis &te );
    virtual bool tick( double tickVal );
    virtual void render( Bild &zRObj );
    // constant
    virtual bool istNochSichtbar() const;
    virtual bool wurdeGeschlossen() const;
};

#endif