#ifndef StatistikTabelle_H
#define StatistikTabelle_H

#include <Tabelle.h>
#include <AuswahlBox.h>
#include <UIInitialization.h>
#include "../SpielStatistikDaten.h"

using namespace Framework;

class StatistikTabelle : public virtual ReferenceCounter
{
private:
    UIInit uiFactory;
    Array< SSDSpieler * > *ssdgs;
    Array< SSDTeam * > *ssdgt;
    AuswahlBox *stAuswahl;
    AuswahlBox *sortAuswahlGS;
    AuswahlBox *sortAuswahlGT;
    AuswahlBox *sortRichtungGS;
    AuswahlBox *sortRichtungGT;
    ObjTabelle *gesamtSpieler;
    ObjTabelle *gesamtTeam;
    bool teamS;
    bool rend;
    // privat
    void tabelleLehren( ObjTabelle *zT, bool berschrift );
    void tabelleFllen( ObjTabelle *zT );

public:
    // Konstruktor
    StatistikTabelle( Array< SSDSpieler * > *ssdgs, Array< SSDTeam * > *ssdgt, UIInit &uiFactory, bool historie = 0 );
    // Destruktor
    ~StatistikTabelle();
    // nicht constant
    void doPublicMausEreignis( MausEreignis &me );
    bool tick( double tickVal );
    void render( Bild &zRObj );
};

#endif